/////////////////////////////////////////////////////////////////
//Feigenbaum-Diagramm
//////////////////////////////////////////////////////////////


//Bildausschnitt zu Beginn:
float rU = 1  ; 
float rO = 5;
float fU = 0; 
float fO = 6;
float lU = -5;
float lO =1.2;
//Zwischenspeicher:
float  rUNeu, rONeu, fUNeu, fONeu;
float lAlt, fAlt, fNeu, d; 
int w = 800; 
int h = 800; 
int NF, LF;
int i; //Iteration Feigenbaum
float flK; // r-Koordinate für beide
float fyK; //y-Koordinaten Feigenbaum
float NullAchseF;
boolean rKoordinatenGezeichnet =false;
float r; //Parameter für logistisches Wachstum

String s; //Zur Beschriftung des Bildes

///////////////////////////////////////////////////////////////////////////

void settings() {
  size(w, h);
} 
//Initialisierungen  
void setup() { 
  background(255); 
  rU =2.8; 
  rO = 3.9;
  fU = -0.05; 
  fO = 1;
  NF= 1000; //Anzahl Iterationen Feigenbaum
  LF =500; //Feigenbaum ab hier gerechnet
  r = rU; //Start r
  d = (rO-rU)/750; //Schrittweite
 
}

void draw() {
  
  if (!rKoordinatenGezeichnet){
     stroke(200,0,0,50);//r-Achse
     strokeWeight(1);
    float deltaS = (rO-rU)/20;
    float rTempK, yTempK;
    float rTemp = rU;
    while(rTemp < rO){
      rTemp = rTemp +deltaS;
      rTempK = map(rTemp , rU, rO, 0, w); //r-Koordinate
      yTempK = map(0, fU, fO, h, 0);  // y-Koordinate
      line(rTempK,0,rTempK, h); 
      line(0,yTempK,w,yTempK );
      s=nf(rTemp,1,3);
      textSize(12);
      fill(200,0,0);
      text(s, rTempK-20, h - 10);
      textSize(16);
      text("r",w-60,h-60);
      rKoordinatenGezeichnet = true; //muss nicht nochmal gezeichnet werden
   }
  }
  if (r<rO){
     r = r +d;
     iteriereF(r);
   }
  
}

/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {  
  background(255);
  rKoordinatenGezeichnet =false;
  rUNeu = map(mouseX, 0, w, rU, rO)-(rO-rU)/10;
  rONeu = map(mouseX, 0, w, rU, rO)+(rO-rU)/10;
  fUNeu = map(mouseY, 0, h, fO, fU)-(fO-fU)/10;
  fONeu = map(mouseY, 0, h, fO, fU)+(fO-fU)/10;
  rU = rUNeu; 
  rO = rONeu; 
  fU = fUNeu; 
  fO = fONeu;
  r = rU; 
  d= d/10;
  NF = NF+100;
  LF = LF+200;
    
}
//////////////////////////////////////////////////////////
//Feigenbaum-Iteration
////////////////////////////////////////////////////////
void iteriereF(float r) {  
  stroke(0);
   strokeWeight(1.2);
  fAlt = 0.5; 
  flK = map(r, rU, rO, 0, w);      
  i=0;
  while (i <=NF) {
    fNeu = r*fAlt*(1-fAlt);
    if (i > LF && abs(fNeu) < 10) {
      fyK = map(fNeu, fU, fO, h, 0);   
      point(flK, fyK);    
    }
    fAlt = fNeu;
    i++;
  }
 
}